-- Copyright (C) 2020  Intel Corporation. All rights reserved.
-- Your use of Intel Corporation's design tools, logic functions 
-- and other software and tools, and any partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Intel Program License 
-- Subscription Agreement, the Intel Quartus Prime License Agreement,
-- the Intel FPGA IP License Agreement, or other applicable license
-- agreement, including, without limitation, that your use is for
-- the sole purpose of programming logic devices manufactured by
-- Intel and sold by Intel or its authorized distributors.  Please
-- refer to the applicable agreement for further details, at
-- https://fpgasoftware.intel.com/eula.

-- ***************************************************************************
-- This file contains a Vhdl test bench template that is freely editable to   
-- suit user's needs .Comments are provided in each section to help the user  
-- fill out necessary details.                                                
-- ***************************************************************************
-- Generated on "07/29/2024 20:44:35"
                                                            
-- Vhdl Test Bench template for design  :  ALU_9bit_top_CLK
-- 
-- Simulation tool : ModelSim-Altera (VHDL)
-- 

LIBRARY ieee;                                               
USE ieee.std_logic_1164.all;                                

ENTITY ALU_9bit_top_CLK_vhd_tst IS
END ALU_9bit_top_CLK_vhd_tst;
ARCHITECTURE ALU_9bit_top_CLK_arch OF ALU_9bit_top_CLK_vhd_tst IS
-- constants                                                 
-- signals                                                   
SIGNAL A : STD_LOGIC_VECTOR(8 DOWNTO 0);
SIGNAL B : STD_LOGIC_VECTOR(8 DOWNTO 1);
SIGNAL C : STD_LOGIC;
SIGNAL CLK_OUT : STD_LOGIC;
SIGNAL EQ : STD_LOGIC;
SIGNAL HEX0_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL HEX1_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL HEX2_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL HEX3_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL HEX4_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL HEX5_L : STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL LED : STD_LOGIC_VECTOR(9 DOWNTO 0);
SIGNAL N : STD_LOGIC;
SIGNAL OP : STD_LOGIC_VECTOR(2 DOWNTO 0);
SIGNAL OSC_CLK_in : STD_LOGIC;
SIGNAL OV : STD_LOGIC;
SIGNAL R : STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL SW9 : STD_LOGIC;
SIGNAL Z : STD_LOGIC;
COMPONENT ALU_9bit_top_CLK
	PORT (
	A : IN STD_LOGIC_VECTOR(8 DOWNTO 0);
	B : IN STD_LOGIC_VECTOR(8 DOWNTO 1);
	C : BUFFER STD_LOGIC;
	CLK_OUT : BUFFER STD_LOGIC;
	EQ : BUFFER STD_LOGIC;
	HEX0_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	HEX1_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	HEX2_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	HEX3_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	HEX4_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	HEX5_L : BUFFER STD_LOGIC_VECTOR(7 DOWNTO 0);
	LED : BUFFER STD_LOGIC_VECTOR(9 DOWNTO 0);
	N : BUFFER STD_LOGIC;
	OP : IN STD_LOGIC_VECTOR(2 DOWNTO 0);
	OSC_CLK_in : IN STD_LOGIC;
	OV : BUFFER STD_LOGIC;
	R : BUFFER STD_LOGIC_VECTOR(15 DOWNTO 0);
	SW9 : IN STD_LOGIC;
	Z : BUFFER STD_LOGIC
	);
END COMPONENT;


   -- Clock period definitions
   constant CLK_period : time := 20 ns;  -- This is 50 MHz from the board crystal


BEGIN
	i1 : ALU_9bit_top_CLK
	PORT MAP (
-- list connections between master ports and signals
	A => A,
	B => B,
	C => C,
	CLK_OUT => CLK_OUT,
	EQ => EQ,
	HEX0_L => HEX0_L,
	HEX1_L => HEX1_L,
	HEX2_L => HEX2_L,
	HEX3_L => HEX3_L,
	HEX4_L => HEX4_L,
	HEX5_L => HEX5_L,
	LED => LED,
	N => N,
	OP => OP,
	OSC_CLK_in => OSC_CLK_in,
	OV => OV,
	R => R,
	SW9 => SW9,
	Z => Z
	);



   -- Clock process definitions
   CLK_signal :process
   begin
		OSC_CLK_in <= '0';
		wait for CLK_period/2;
		OSC_CLK_in <= '1';
		wait for CLK_period/2;
   end process;
   
   
stim_proc: process
   begin		
     
      wait for 70 ns;	
		wait for CLK_Period*5.2;
		
	-- ACTIVITY:Logic bitwise operations
	
-- Let's check the C_out (C) flag imagining imagining radix-2 numbers
-- that switch all outputs 
		A <= "011111111";  -- = 255 
		B <= "10000000"; -- (256 / 257 )	-- This is only B(8..1) + B(0)
		-- B(0) is supplied by the internally generated CLK_OUT signal
		
		SW9 <= '1';  -- Select the 5 MHz waveforms
		
		
		OP <=  "100";			--  A+B  ==> 511 (with B0 = '0')  - 0 111111111 
								--  A+B  ==> 512 (with B0 = '1')  - 1 000000000 
		wait for CLK_Period*2000;		
	
		--Add other input vectors and solve more operations,
		-- select the 10 kHz frequency

		SW9 <= '0';  -- Select the 10 kHz waveform

		wait for CLK_Period*2000;

      wait;
   end process;





                                       
END ALU_9bit_top_CLK_arch;
